﻿/*
 * $Id: ActorPools.cs,v 1.2 2009/08/22 13:32:11 kenta Exp $
 *
 * Copyright 2009 Kenta Cho. Some rights reserved.
 */
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Abagames.Util;
using Abagames.Util.Ssl;

namespace Abagames.HundredMonkeys
{
    class ActorPools
    {
        private Frame frame;
		private Field field;
		private Boss boss;
		private BulletPool bullets;
		private MonkeyPool monkeys;
		private ParticlePool particles;

        public ActorPools(Frame frame, ContentManager content, Pad pad)
        {
            this.frame = frame;
			field = new Field(frame);
			particles = new ParticlePool(5000, frame);
			SslbPool sslbs = new SslbPool();
			sslbs.Add(content.Load<List<Sslb>>(@"Sslb\Base"));
			bullets = new BulletPool(200, frame, field, sslbs, particles);
			boss = new Boss(frame, field, sslbs, bullets);
			monkeys = new MonkeyPool(200, frame, field, bullets, particles);
		}

        public void Initialize(int randomSeed)
        {
			bullets.Clear();
			monkeys.Clear();
			particles.Clear();
			for (int i = 0; i < monkeys.Actors.Length; i++)
				monkeys.Add();
        }

		public void Update()
        {
			particles.Update();
			boss.Update();
			bullets.Update();
			monkeys.Update();
			field.Update();
        }

        public void Draw()
        {
			//frame.LookAt(new Vector3(0, 0, 100), Vector3.Zero, Vector3.Up);
			frame.LookAt(new Vector3(0, -40, 53), new Vector3(0, -10, 0), Vector3.Up);
			field.Draw();
			boss.Draw();
			bullets.Draw();
			monkeys.Draw();
        }

        public void DrawParticle()
        {
			particles.Draw();
		}

        public void DrawPanel()
        {
        }

        public void DrawGameState()
        {
			monkeys.DrawIndexes();
			//Letter.Draw();
        }
    }
}
