/*
 * $Id: Ssl.cs,v 1.1.1.1 2009/08/22 11:57:02 kenta Exp $
 *
 * Copyright 2008 Kenta Cho. Some rights reserved.
 */
using System;
using System.Collections.Generic;

namespace Abagames.Util.Ssl
{
    /// <summary>
    /// 
    /// </summary>
    public interface Command
    {
    }

    public interface NestedCommand : Command
    {
        List<Command> Commands { get; }
        int CommandsId { get; set;  }
    }

    public class Ssl : NestedCommand
    {
        public string Name;
        public List<Expression> DefaultArguments;
        public List<Command> Commands { get; set; }
        public int CommandsId { get; set; }

        public Ssl()
        {
            Name = "";
            DefaultArguments = new List<Expression>();
            Commands = new List<Command>();
        }
    }

    public class Repeat : NestedCommand
    {
        public Expression Count;
        public List<Command> Commands { get; set; }
        public int CommandsId { get; set; }
    }

    public class Wait : Command
    {
        public Expression Term;
    }

    public class Vanish : Command
    {
    }

    public class Call : Command
    {
        public string Name;
        public List<Expression> Arguments;
    }
}
