/*
 * $Id: SslbPool.cs,v 1.1.1.1 2009/08/22 11:57:02 kenta Exp $
 *
 * Copyright 2008 Kenta Cho. Some rights reserved.
 */
using System;
using System.Collections.Generic;

namespace Abagames.Util.Ssl
{
    /// <summary>
    /// 
    /// </summary>
    public class SslbPool
    {
        private Dictionary<string, Sslb> sslbDictionary;
        private List<List<Command>> commandsList;

        public SslbPool()
        {
            sslbDictionary = new Dictionary<string, Sslb>();
            commandsList = new List<List<Command>>();
        }

        public void Add(List<Sslb> sslbs)
        {
            foreach (Sslb sslb in sslbs)
            {
                sslbDictionary.Add(sslb.Name, sslb);
                AddNestedCommand(sslb);
            }
        }

        private void AddNestedCommand(NestedCommand nc)
        {
            if (nc.Commands == null)
                return;
            nc.CommandsId = commandsList.Count;
            commandsList.Add(nc.Commands);
            foreach (Command c in nc.Commands)
            {
                if (c is NestedCommand)
                    AddNestedCommand((NestedCommand)c);
            }
        }

        public Dictionary<string, Sslb> SslbDictionary
        {
            get
            {
                return sslbDictionary;
            }
        }

        public List<List<Command>> CommandsList
        {
            get
            {
                return commandsList;
            }
        }
    }
}
