/*
 * $Id: SslbImporter.cs,v 1.1.1.1 2009/08/22 11:57:02 kenta Exp $
 *
 * Copyright 2008 Kenta Cho. Some rights reserved.
 */
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;

namespace Abagames.Util.Ssl
{
    /// <summary>
    /// 
    /// </summary>
    [ContentImporter(".sslb", DisplayName = "SSL-B File Importer")]
    public class SslbImporter : SslImporter<Sslb>
    {
        public override void ParseCommand(string[] strs)
        {
            switch (strs[0])
            {
                case "fire":
                case "afire":
                case "rfire":
                    Fire f;
                    if (strs[0] == "fire")
                        f = new Fire();
                    else if (strs[0] == "afire")
                        f = new AimFire();
                    else
                        f = new ResetFire();
                    f.Commands = new List<Command>();
                    nestedCommands = f.Commands;
                    commands.Add(f);
                    if (strs.Length <= 1)
                        break;
                    f.Angle = new Expression(strs[1]);
                    if (strs.Length <= 2)
                        break;
                    f.Speed = new Expression(strs[2]);
                    break;
                case "spd":
                    Speed s = new Speed();
                    s.Value = new Expression(strs[1]);
                    commands.Add(s);
                    if (strs.Length <= 2)
                        break;
                    s.Term = new Expression(strs[2]);
                    break;
                default:
                    AddCall(strs);
                    break;
            }
        }
    }
}
