using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace Abagames.Util.Ssl
{
    [ContentTypeWriter]
    public class ExpressionWriter : ContentTypeWriter<Expression>
    {
        protected override void Write(ContentWriter output, Expression value)
        {
            output.WriteObject<Expression.Operator[]>(value.Operators.ToArray());
            output.WriteObject<List<float>>(value.Numbers);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(ExpressionReader).AssemblyQualifiedName;
        }
    }

    [ContentTypeWriter]
    public class OperatorWriter : ContentTypeWriter<Expression.Operator>
    {
        protected override void Write(ContentWriter output, Expression.Operator value)
        {
            output.WriteObject<Expression.Operator.Type>(value.OperatorType);
            output.WriteObject<int>(value.Index);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(OperatorReader).AssemblyQualifiedName;
        }
    }
}
